<?php

namespace App\Models;

use App\Entities\CategoryEntity;

class CategoryModel extends BaseHierarchyModel
{
    protected $table = "tw_category";
    protected $returnType = CategoryEntity::class;
    public function __construct()
    {
        parent::__construct('Category');
        $this->allowedFields = [
            ...$this->allowedFields,
            'name', "isaccess", "isread", "iswrite", "isreply", "isupload", "isdownload",
            "head", "tail", "status"
        ];
        $this->validationRules = [...$this->validationRules, ...$this->getFieldRules($this->allowedFields),];
    }
    public function getTitleField(): string
    {
        return 'name';
    }
    public function getContentField(): string
    {
        return 'head';
    }
    protected function getFieldRule(string $field, array $rules, string $action = ""): array
    {
        switch ($field) {
            case $this->getTitleField():
                $rules[$field] = "required|trim|string";
                $rules[$field] .= $action == "insert" ? "|is_unique[{$this->table}.{$field}]" : "";
                break;
            case "isaccess":
            case "isread":
            case "iswrite":
            case "isreply":
            case "isupload":
            case "isdownload":
                //아래 Rule은 입력시에는 되는데 수정시에는 않됨 이유를 ?
                // $rules[$field] =   "required|in_list[master,director,cloudflare,manager,gold,silver,brone,vip,user,guest]";
                //아래 Rule은 checkbox를 사용시에는 required만 우선 써야 수정시 validate문제없음
                $rules[$field] = "required";
                break;
            default:
                $rules = parent::getFieldRule($field, $rules, $action);
                break;
        }
        return $rules;
    }
    //Form 선택용 Options Data용
    public function getOptions(array $conditions = array(), $options = array()): array
    {
        //대분류 부분은 선택이 되지 않게 하기위해 따로 만듬 (form_dropdown의 optgroup 기능)
        $old_title = "";
        foreach ($this->getEntitys($conditions) as $entity) {
            if ($entity->getHierarchy_Depth() == 1) {
                $options[$entity->getTitle()] = [];
                $old_title = $entity->getTitle();
            } else {
                $options[$old_title][$entity->getPrimaryKey()] = $entity->getTitle();
            }
        }
        return $options;
    }
    //Field별 Form Option용
    protected function changeFormData(string $action, string $field, array $formDatas, $entity)
    {
        switch ($field) {
            case "isaccess":
            case "isread":
            case "iswrite":
            case "isreply":
            case "isupload":
            case "isdownload":
                if (array_key_exists($field, $formDatas)) {
                    $entity->$field = is_array($formDatas[$field]) ? implode(DEFAULTS['DELIMITER_ROLE'], $formDatas[$field]) : $formDatas[$field];
                }
                break;
            case "head":
            case "tail":
                if (array_key_exists($field, $formDatas)) {
                    $entity->$field = htmlentities($formDatas[$field]);
                }
                break;
            default:
                $entity = parent::changeFormData($action, $field, $formDatas, $entity);
                break;
        }
        return $entity;
    }

    public function getEntity($conditions): CategoryEntity
    {
        return parent::getEntity($conditions);
    }
    public function getEntitys(array $conditions = array()): array
    {
        return $this->where($conditions)->orderby("grpno DESC, grporder ASC")->findAll();
    }
    public function create(array $formDatas): CategoryEntity
    {
        return $this->create_process(new CategoryEntity(), $formDatas);
    }
    public function modify(CategoryEntity $entity, array $formDatas): CategoryEntity
    {
        return $this->modify_process($entity, $formDatas);
    }
    public function reply($parent_entity, array $formDatas): CategoryEntity
    {
        return $this->reply_process($parent_entity, new CategoryEntity(), $formDatas);
    }

    //Index관련
    public function setIndexWordFilter(string $word)
    {
        parent::setIndexWordFilter($word);
        $this->orLike($this->getTitleField(), $word, "both");
        $this->orLike("head", $word, "both"); //befor , after , both
        $this->orLike("tail", $word, "both"); //befor , after , both
    }
}
